#pragma once

#include		"stdThread.h"
#include		"MySyncObject.h"

// 書きこむ位置が lTail
// 読み出す位置が lHead
// lHead = lTailの時はバッファに何も入っていないと定義
// 0----Head-----Tail-----AllocSize  size:T-H
// 0----Tail-----Haed-----AllocSize  size:(A-H) + T

class CRingBuff
{
public:
	CRingBuff(long lMaxSize);
	~CRingBuff(void);

	long		Read(LPBYTE pbBuf, long lSize = 1);
	long		ReadWithoutUpdateHeadPoint(LPBYTE pbBuf, long lSize = 1);
	void		UpdateHeadPoint(long lSize = 1);
	BOOL		Write(LPBYTE pbBuf, long lSize = 1);
	long		GetReadableSize();
	long		GetWriteableSize();
	void		Clear();

private:
	long		GetReadableSize0();		// ★同期なし版
	long		GetWriteableSize0();	// ★同期なし版

	LPBYTE		m_pbData;				// バッファの実体
	long		m_lMaxSize;				// バッファの最大サイズ
	long		m_lAllocSize;			// 実体の確保サイズ=バッファの最大サイズ+1
	long		m_lHead;				// 読み込み開始位置
	long		m_lTail;				// 書き込み開始位置
	CMySyncObject *m_pCMySyncObject;	// 同期用

public:
	BOOL		m_fInitialized;			// 初期化できたか
};
