#include	"ThreadJob.h"

// pthread_createに渡す関数
// グローバル(クラスのインスタンスとは無関係)に配置されます
// 当然クラスのメンバにはアクセスできないので
// クラスのインスタンス(this)をパラメータとして渡して呼び出す
void *ThreadFunc(void *pvoid);


//----------------------------------------------
// function
//    コンストラクタ
// parameter
//    MyDataRec *pData	[in]機能に必要な情報
// return
//    なし
//----------------------------------------------
CThreadJob::CThreadJob(void)
{
// メンバ変数の初期化
    m_idThread	= 0;
    m_fStopFlag	= FALSE;
}

//----------------------------------------------
// function
//    デストラクタ
// parameter
//    なし
// return
//    なし
//----------------------------------------------
CThreadJob::~CThreadJob(void)
{
}

//----------------------------------------------
// function
//		スレッド開始
// parameter
//		なし
// return
//		TRUE/FALSE
//----------------------------------------------
BOOL CThreadJob::Begin()
{
	int		iRet;
	BOOL    fRet;

	m_fStopFlag = FALSE;
	// ThreadProcがクラスメンバにアクセスできるように
	// クラス(実際は派生クラス)のインスタンスのポインタを引数として渡す
	iRet = pthread_create(&m_idThread, NULL, ThreadFunc, this);
	fRet = (iRet != 0) ? FALSE : TRUE;
	return(fRet);
}

//----------------------------------------------
// function
//		スレッドへ終了を通知
// parameter
//		なし
// return
//		なし
//----------------------------------------------
void CThreadJob::End()
{
	m_fStopFlag = TRUE;
}

//----------------------------------------------
// function
//		スレッド終了を待つ
// parameter
//		なし
// return
//		スレッドで実行した関数の戻り値
//----------------------------------------------
DWORD CThreadJob::WaitForEnd()
{
	DWORD	dwRet;
	void	*pResult;

//	pthread_join(m_idThread, NULL);
	pthread_join(m_idThread, &pResult);
//	fprintf(stderr, "%s\n", (char *)pResult);
//	fprintf(stderr, "%d\n", *(int *)pResult);
	dwRet = *(DWORD *)pResult;
	SAFE_FREE(pResult)
	return(dwRet);
}

//----------------------------------------------
// function
//		別スレッドで実行する関数
//		派生クラスでオーバライドされるDoWorkを呼び出す
// parameter
//		void *pvoid	[in]CThreadJobのインスタンス
// return
//		実行結果
//----------------------------------------------
void *ThreadFunc(void *pvoid)
{
//	char	*pszResult = (char *)calloc(40, sizeof(char));
	DWORD	*pdwResult = (DWORD *)calloc(1, sizeof(DWORD));	// 返す値はエリアを確保
								
	CThreadJob  *pCThreadJob = (CThreadJob *)pvoid;
	*pdwResult = pCThreadJob->DoWork();
//	strcpy(pszResult, "End OK");
	printf("ThreadFunc End\n");		// pthread_exitより前に書かないと実行されません
	pthread_exit(pdwResult);		// 返す値はこの関数に渡す
//	pthread_exit(pszResult);
//	pthread_exit(NULL);
	return(NULL);
}




